package vo

//从订单MQTT中获取的消息
type MQTTOrder struct {
	Topic        string `json:"topic"`        //主题
	MsgId        string `json:"msgId"`        //消息ID
	OrderId      string `json:"orderId"`      //订单号
	OrderEndTime int64  `json:"orderEndTime"` //支付完成时间，unix时间戳
	Price        string `json:"price"`        //订单原价（小数点后6位）
	Amount       string `json:"amount"`       //支付金额（小数点后6位）
	Bean         string `json:"bean"`         //抵扣金豆
	ShopId       string `json:"shopId"`       //店铺ID
	OpenId       string `json:"openId"`       //微信或支付宝用户Id
	Channel      int    `json:"channel"`      //1微信2支付宝
	Mobile       string `json:"mobile"`       //付款用户手机号
	SendTime     int64  `json:"sendTime"`     //发送消息时间,unix时间戳
}

//发送到机器猫的MQTT消息
type MQTTDevice struct {
	MsgId    string `json:"msgId"`    //消息编号
	Type     string `json:"type"`     //1支付宝 2微信 3银联云闪付 99文字转语音播 100测试播报语音
	Template string `json:"template"` //tts语音播板
	Amount   string `json:"amount"`   //播报金额
	Nonce    string `json:"nonce"`    //随机数
	Sign     string `json:"sign"`     //签名
}
